package bookExamples.ch26Graphics.sprials;

import gui.ClosableJFrame;
import gui.run.RunButton;
import gui.run.RunCheckBox;
import gui.run.RunComboBox;

import javax.swing.*;
import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

public class SpiralsAndTrails extends JPanel {
    Point start;
    Point top;
    Point now;
    Point wave;
    Point oldwave;
    int width;
    int height;
    int sX;
    int sY;
    int ix;
    int iy;
    int Rval;
    int Gval;
    int Bval;
    boolean clear;
    boolean busy;
    String ButtonEvent;
    String drawToolString;
    boolean trails = false;

    public SpiralsAndTrails() {
        getBcp();
        setBackground(Color.black);
        start = new Point(0, 0);
        top = new Point(0, 0);
        now = new Point(0, 0);
        wave = new Point(0, 0);
        oldwave = new Point(0, 0);
        drawToolString = "drawOval";
        addMouseListener(getMouseListener());
        addMouseMotionListener(getMouseMotionListener());
    }

    private JPanel getBcp() {
        JPanel jp = new JPanel();
        jp.setLayout(new FlowLayout());

        String s[] = {
                "drawOval",
                "drawRect"
        };
        jp.add(new RunComboBox(s) {
            public void run() {
                drawToolString = (String) getSelectedItem();
            }
        });

        jp.add(new RunButton("Zip1") {
            public void run() {
                drawToolString = "drawZip";
                sX = 269;
                sY = 230;
            }
        });
        jp.add(new RunButton("Zip2") {
            public void run() {
                drawToolString = "drawZip";
                sX = 241;
                sY = 361;
            }
        });
        jp.add(new RunButton("Zip3") {
            public void run() {
                drawToolString = "drawZip";
                sX = 95;
                sY = 57;
            }
        });
        jp.add(new RunButton("Zip4") {
            public void run() {
                drawToolString = "drawZip";
                sX = 229;
                sY = 220;
            }
        });
        jp.add(new RunCheckBox("trails ") {
            public void run() {
                trails = this.isSelected();
            }
        });
        return jp;
    }

    public void drawZip(Graphics g) {
        double angle = 0.0D;
        int Xval[] = new int[257];
        int Yval[] = new int[257];
        if (!busy) {
            busy = true;
            int ampX = now.x - start.x;
            int ampY = now.y - start.y;
            for (int i = 0; i <= 256; i++) {
                Xval[i] = start.x + (int) Math.ceil((double) ampX * Math.sin((double) sX * angle));
                Yval[i] = start.y + (int) Math.ceil((double) ampY * Math.sin((double) sY * angle));
                angle += 0.024543692606170259D;
            }

            Polygon poly = new Polygon(Xval, Yval, 257);
            g.drawPolygon(poly);
            busy = false;
        }
    }

    public void selectColor(int i, int j) {
        int c = (i - 512) / 2;
        if (c < 0)
            c = -c;
        int d = ((j - 375) / 3) * 2;
        if (d < 0)
            d = -d;
        int x = i - 512;
        if (x < 0)
            x = -x;
        int y = j - 375;
        if (y < 0)
            y = -y;
        int e = ((896 - x - y) / 7) * 2;
        if (c > 255)
            c = 255;
        if (d > 255)
            d = 255;
        if (e > 255)
            e = 255;
        Rval = 255 - c;
        Gval = 255 - d;
        Bval = 255 - e;
    }

    public MouseMotionListener getMouseMotionListener() {
        return new MouseMotionListener() {

            public void mouseDragged(MouseEvent e) {
                clear = false;
                int x = e.getX();
                int y = e.getY();
                drawNow(x, y);
                selectColor(x, y);
            }

            public void mouseMoved(MouseEvent e) {

            }
        };
    }

    public MouseListener getMouseListener() {
        return new MouseListener() {

            public void mouseClicked(MouseEvent e) {
                //To change body of implemented methods use File | Settings | File Templates.
            }

            public void mousePressed(MouseEvent e) {
                int x = e.getX();
                int y = e.getY();
                start.x = x;
                start.y = y;
            }

            public void mouseReleased(MouseEvent e) {
                //To change body of implemented methods use File | Settings | File Templates.
            }

            public void mouseEntered(MouseEvent e) {
                //To change body of implemented methods use File | Settings | File Templates.
            }

            public void mouseExited(MouseEvent e) {
                //To change body of implemented methods use File | Settings | File Templates.
            }
        };
    }


    void drawNow(int x, int y) {
        top.x = 2 * start.x - x;
        top.y = 2 * start.y - y;
        now.x = x;
        now.y = y;
        if (top.x >= now.x)
            ix = now.x;
        else
            ix = top.x;
        if (top.y >= now.y)
            iy = now.y;
        else
            iy = top.y;
        width = top.x - now.x;
        if (width < 0)
            width = -width;
        height = top.y - now.y;
        if (height < 0)
            height = -height;
        repaint();
    }

    public void paint(Graphics g) {
        if (trails) super.paint(g);
        g.setColor(new Color(Rval, Gval, Bval));
        if (drawToolString.equals("drawOval"))
            g.drawOval(ix, iy, width, height);
        if (drawToolString.equals("drawRect"))
            g.drawRect(ix, iy, width, height);
        if (drawToolString.equals("drawZip"))
            drawZip(g);
        if (clear)
            g.clearRect(0, 0, getSize().width, getSize().height);
        clear = false;
    }


    public static void main(String[] args) {
        ClosableJFrame cf = new ClosableJFrame();
        Container c = cf.getContentPane();
        c.setLayout(new BorderLayout());
        SpiralsAndTrails s = new SpiralsAndTrails();
        c.add(s.getBcp(), BorderLayout.SOUTH);
        c.add(s, BorderLayout.CENTER);
        cf.setSize(700, 600);
        cf.setVisible(true);
    }

}
